#include <iostream>   
#include <string>
#include <sstream>
#include <thread>
// #error This file requires compiler and library support for the ISO C++ 2011 standard.
// This support is currently experimental, and must be enabled with the
// -std=c++11 or -std=gnu++11 compiler options.
using namespace std;

const string sign( " -> start" );
 
void fun1() {
   ostringstream msg; 
   msg << __FUNCTION__ << "()" << sign << endl; 
   cout << msg.str();
}

void fun2( int x ) {
   ostringstream msg; 
   msg << __FUNCTION__ << "(" << x << ")" << sign << endl;
   cout << msg.str(); 
}

struct block { double f; string s; };

void fun3( int x, float y, string z, block w ) {
   ostringstream msg; 
   msg << __FUNCTION__ << "(" << x << ", " << y << ", "
       << z << ", {" << w.f << ", " << w.s << "}" 
       << sign << endl;
   cout << msg.str(); 
}

int main() {
  block blk = { 0.123, string( "блочный параметр" ) }; 
  thread thr[] = { thread( fun1 ), 
                   thread( fun2, 123 ), 
                   thread( fun3, 123, 0.123e2, string( "параметр" ), blk ) };
  cout << "потоки выполняются конкурентно...\n";
  for( uint i = 0; i < sizeof( thr ) / sizeof( thr[ 0 ] ); i++ )
     thr[ i ].join();     // это корректно, но почему? ;-)
  cout << "все потоки завершились!" << endl;
  return 0;
}
